package config

import "github.com/aykhans/oh-my-chat/internal/core/utils"

type ScyllaConfig struct {
	Hosts      []string
	DataCenter string
	Keyspace   string
	User       string
	Password   string
}

func NewScyllaConfig() *ScyllaConfig {
	return &ScyllaConfig{
		Hosts:      utils.Str2StrSlice(GetEnvOrDie("SCYLLA_HOSTS")),
		DataCenter: GetEnvOrDie("SCYLLA_DATACENTER"),
		Keyspace:   GetEnvOrDie("SCYLLA_KEYSPACE"),
		User:       GetEnvOrDie("SCYLLA_USER"),
		Password:   GetEnvOrDie("SCYLLA_PASSWORD"),
	}
}
